from datetime import datetime
import pyodbc
import keyboard
import serial
import time

# Open the serial port.
ser = serial.Serial()
ser.baudrate = 9600
ser.port = 'COM3' # ******** Adapt the serial port according to your connection. ********
ser.open()

# Start the connection to the Access DB. ******** Adapt the path after DBQ according to your needs. ********
conn = pyodbc.connect(r'Driver={Microsoft Access Driver (*.mdb, *.accdb)};DBQ=C:\temp\Access\RFID_Database_be.accdb;')
# Get a connection cursor.
cursor = conn.cursor()
# Now wait forever on keyboard sequences - just until anybody presses "q".
keepRunning = True
while keepRunning:
    if keyboard.is_pressed("q"): # Terminate the program using the 'Q' key.
        keepRunning = False 
    if(ser.in_waiting >= 12): # Wait until there is (at least) one full code in the input buffer.
        buffer = ser.read(12)
        cardID = buffer[:10].decode("utf-8") # Assume the code does not contain hex numbers.
        if(cardID.isdigit()):
            # If receiving the system sporadically misses single digits from the reader, 
            # or if any other problems can occur, add code for checking the ID here.
            # *******************
            # Go on sending the code to the database now.
            # Create SQL query.
            now = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
            query = "INSERT INTO RFID_Codes (CardID, StampTime) VALUES (%s, '%s')" % (cardID, now)
            print(query)
            # Add the new record to the database...
            cursor.execute(query)
            # ...and make it persistent.
            conn.commit()   
    time.sleep(.05) # Give the PC some time to do other stuff.
## The following lines print the entire contents of the database table. This can be used for debgging.
#cursor.execute('select * from RFID_Codes')
#for row in cursor.fetchall():
#   print (row)
# Close the serial port.
ser.close()
# Close the database connection.
cursor.close()
conn.close()









